// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"fmt"
	"io"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	"github.com/cisco-open/kubei/api/client/models"
)

// GetPackagesReader is a Reader for the GetPackages structure.
type GetPackagesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetPackagesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetPackagesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewGetPackagesDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetPackagesOK creates a GetPackagesOK with default headers values
func NewGetPackagesOK() *GetPackagesOK {
	return &GetPackagesOK{}
}

/* GetPackagesOK describes a response with status code 200, with default header values.

Success
*/
type GetPackagesOK struct {
	Payload *GetPackagesOKBody
}

func (o *GetPackagesOK) Error() string {
	return fmt.Sprintf("[GET /packages][%d] getPackagesOK  %+v", 200, o.Payload)
}
func (o *GetPackagesOK) GetPayload() *GetPackagesOKBody {
	return o.Payload
}

func (o *GetPackagesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(GetPackagesOKBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetPackagesDefault creates a GetPackagesDefault with default headers values
func NewGetPackagesDefault(code int) *GetPackagesDefault {
	return &GetPackagesDefault{
		_statusCode: code,
	}
}

/* GetPackagesDefault describes a response with status code -1, with default header values.

unknown error
*/
type GetPackagesDefault struct {
	_statusCode int

	Payload *models.APIResponse
}

// Code gets the status code for the get packages default response
func (o *GetPackagesDefault) Code() int {
	return o._statusCode
}

func (o *GetPackagesDefault) Error() string {
	return fmt.Sprintf("[GET /packages][%d] GetPackages default  %+v", o._statusCode, o.Payload)
}
func (o *GetPackagesDefault) GetPayload() *models.APIResponse {
	return o.Payload
}

func (o *GetPackagesDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.APIResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetPackagesOKBody get packages o k body
swagger:model GetPackagesOKBody
*/
type GetPackagesOKBody struct {

	// List of packages in the given filters and page. List length must be lower or equal to pageSize
	Items []*models.Package `json:"items"`

	// Total packages count under the given filters
	// Required: true
	Total *int64 `json:"total"`
}

// Validate validates this get packages o k body
func (o *GetPackagesOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateItems(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateTotal(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetPackagesOKBody) validateItems(formats strfmt.Registry) error {
	if swag.IsZero(o.Items) { // not required
		return nil
	}

	for i := 0; i < len(o.Items); i++ {
		if swag.IsZero(o.Items[i]) { // not required
			continue
		}

		if o.Items[i] != nil {
			if err := o.Items[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getPackagesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *GetPackagesOKBody) validateTotal(formats strfmt.Registry) error {

	if err := validate.Required("getPackagesOK"+"."+"total", "body", o.Total); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this get packages o k body based on the context it is used
func (o *GetPackagesOKBody) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := o.contextValidateItems(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetPackagesOKBody) contextValidateItems(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(o.Items); i++ {

		if o.Items[i] != nil {
			if err := o.Items[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("getPackagesOK" + "." + "items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetPackagesOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetPackagesOKBody) UnmarshalBinary(b []byte) error {
	var res GetPackagesOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
